package com.diagbot.repository;

import com.diagbot.dto.DrugBillNeoDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.entity.node.*;
import com.diagbot.util.NeoUtil;

import java.math.BigDecimal;
import java.util.Set;

public class MedicineNode {


    public DrugBillNeoDTO MedicinetoDrugDTO(Medicine medicine) {
        DrugBillNeoDTO drugBillNeoDTO = new DrugBillNeoDTO();

        Age age = medicine.getAge();
        if (age!=null) {
            NodeNeoDTO ageNeoDTO = new NodeNeoDTO();
            ageNeoDTO.setMin(BigDecimal.valueOf(age.getMinval()));
            ageNeoDTO.setMax(BigDecimal.valueOf(age.getMaxval()));
            drugBillNeoDTO.setAgeNeoDTO(ageNeoDTO);
        }


        Gender gender = medicine.getGender();
        if (gender!=null) {
            drugBillNeoDTO.setGender(NeoUtil.updateNodeInfo(gender.getName(), null, null, null));
        }


        Set<ClinicalFinding> clinicalfindings = medicine.getClinicalfindings();
        for (ClinicalFinding clinicalfinding : clinicalfindings) {
            String name = clinicalfinding.getName();
            String min = clinicalfinding.getMinval();
            String max = clinicalfinding.getMaxval();
            String unit = clinicalfinding.getUnit();
            drugBillNeoDTO.getClinicfindings().add(NeoUtil.updateNodeInfo(name, min, max, unit));
        }


        Set<LIS> lisset = medicine.getLisset();
        for (LIS lis : lisset) {
            String name = lis.getName();
            String min = lis.getMinval();
            String max = lis.getMaxval();
            String unit = lis.getUnit();
            drugBillNeoDTO.getLis().add(NeoUtil.updateNodeInfo(name, min, max, unit));
        }


        Set<PACS> pacsset = medicine.getPacs();
        for (PACS pacs : pacsset) {
            String name = pacs.getName();
            String min = pacs.getMinval();
            String max = pacs.getMaxval();
            String unit = pacs.getUnit();
            drugBillNeoDTO.getPacs().add(NeoUtil.updateNodeInfo(name, min, max, unit));
        }


        Set<AllergicMed> allergicmeds = medicine.getAllergicmeds();
        for (AllergicMed allergicmed: allergicmeds) {
            String name = allergicmed.getName();
            drugBillNeoDTO.getAllergicmeds().add(NeoUtil.updateNodeInfo(name, null, null, null));
        }


        Set<Operation> operations = medicine.getOperations();
        for (Operation operation : operations) {
            String name = operation.getName();
            drugBillNeoDTO.getOperations().add(NeoUtil.updateNodeInfo(name, null, null, null));
        }


        Set<Procedure> procedures = medicine.getProcedures();
        for (Procedure procedure : procedures) {
            String name = procedure.getName();
            drugBillNeoDTO.getProcedures().add(NeoUtil.updateNodeInfo(name, null, null, null));
        }


        Set<Disease> diseases = medicine.getDiseases();
        for (Disease disease : diseases) {
            String name = disease.getName();
            drugBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(name, null, null, null));
        }


        Set<Group> groups = medicine.getGroups();
        for (Group group : groups) {
            String name = group.getName();
            drugBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(name, null, null, null));
        }


        Set<ConflictMed> conflict_medicines = medicine.getConflictmeds();
        for (ConflictMed conflict_medicine : conflict_medicines) {
            String name = conflict_medicine.getName();
            drugBillNeoDTO.getPrescribe().add(NeoUtil.updateNodeInfo(name, null, null, null));
        }


        return drugBillNeoDTO;
    }
}

