package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.util.CoreUtil;

import java.math.BigDecimal;

/**
 * @description: 年龄规则
 * @author: zhoutg
 * @time: 2020/8/3 14:47
 */
public class AgeRule {

    /**
     * 年龄比较
     *
     * @param ageNeoDTO
     * @param wordCrfDTO
     * @param billNeoMaxDTO
     * @return
     */
    public static BillMsg compareAgeWithBill(NodeNeoDTO ageNeoDTO, WordCrfDTO wordCrfDTO, BillNeoMaxDTO billNeoMaxDTO) {
        Boolean flag = false;
        if (ageNeoDTO != null && wordCrfDTO.getAge() != null) {
            Integer age = wordCrfDTO.getAge();
            BigDecimal min = ageNeoDTO.getMin();
            BigDecimal max = ageNeoDTO.getMax();

            if (min != null && max != null) {
                int minAge = min.intValue();
                int maxAge = max.intValue();
                if (minAge <= age && age <= maxAge) {
                    flag = true;
                }
            } else if (min != null && max == null) {
                int minAge = min.intValue();
                if (minAge <= age) {
                    flag = true;
                }
            } else if (min == null && max != null) {
                int maxAge = max.intValue();
                if (age <= maxAge) {
                    flag = true;
                }
            }
        }
        if (flag) {
            return CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(),
                    String.valueOf(wordCrfDTO.getAge() + "岁"), String.valueOf(wordCrfDTO.getAge() + "岁"));
        }
        return null;
    }
}
