package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.model.entity.Negative;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.StringUtil;
import org.apache.commons.lang3.StringUtils;
import org.neo4j.ogm.annotation.NodeEntity;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @description: 实验室检查和辅助检查规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class DiagRule {
    /**
     * 比较疾病
     *
     * @param drugLises
     * @param inputLises
     * @return
     */
    public static <T> BillMsg compareDiseaseWithBill(List<NodeNeoDTO> drugLises, List<T> inputLises, String name) {
        Map<String,String> old_stand = new HashMap<>();
        if(ListUtil.isNotEmpty(drugLises) && ListUtil.isNotEmpty(inputLises)){
            List<String> dl = drugLises.stream().map(x -> x.getName()).collect(Collectors.toList());
            for (T d:inputLises) {
                Negative val = (Negative)CoreUtil.getFieldValue(d, "negative");
                if(val == null){
                    String c = (String) CoreUtil.getFieldValue(d, "standName");
                    String c_name = (String) CoreUtil.getFieldValue(d, "name");
                    if(StringUtils.isNotBlank(c) && dl.contains(c)){
                        old_stand.put(c_name,c);
                    }
                }
            }
            if(old_stand.size() > 0){
                String message = StringUtils.join(old_stand.keySet(), ",");
                String standNames = StringUtils.join(old_stand.values().stream().collect(Collectors.toList()),",");
                BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(message, name,standNames);
                return commonBillMsg;
            }
        }
        return null;
    }
}
