package com.diagbot.rule;

import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @description: 化验规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class LisRule {
    /**
     * 比较辅检
     *
     * @param drugLis
     * @param inputLis
     * @return
     */
    public static BillMsg compareLisWithBill(List<NodeNeoDTO> drugLis, List<Lis> inputLis, String name) {

        Map<String,String> old_stand = new HashMap<>();
        if(ListUtil.isNotEmpty(drugLis) && ListUtil.isNotEmpty(inputLis)){
            Map<String, BigDecimal> nameMax = drugLis.stream().collect(Collectors.toMap(NodeNeoDTO::getName, NodeNeoDTO::getMax));
            Map<String, BigDecimal> nameMin = drugLis.stream().collect(Collectors.toMap(NodeNeoDTO::getName, NodeNeoDTO::getMin));

            for (Lis lis:inputLis) {
                String val =lis.getUniqueName();
                String val_name = lis.getDetailName();

                if(StringUtils.isNotBlank(val)){
                    if(nameMax.containsKey(val) && lis.getValue() > nameMax.get(val).doubleValue()){
                        old_stand.put(val_name,"大于"+lis.getValue().toString());
                    }
                    if(nameMin.containsKey(val) && lis.getValue() < nameMin.get(val).doubleValue()){
                        old_stand.put(val_name,"小于"+lis.getValue().toString());
                    }

                }
            }
        }
        if(old_stand.size() > 0){
            String message =null;
            for (Map.Entry<String,String> ds:old_stand.entrySet()) {
                message +=ds.getKey()+ds.getValue()+",";
            }
//            String message = StringUtils.join(old_stand.keySet(), ",");
//            String standNames = StringUtils.join(old_stand.values().stream().collect(Collectors.toList()),",");
            BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(message, name,null);
            return commonBillMsg;
        }
        return null;
    }
}
