package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import org.apache.commons.lang3.StringUtils;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @description: 疾病规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class PacsRule {
    /**
     * 比较辅检
     *
     * @param drugLis
     * @param inputLis
     * @return
     */
    public static <T> BillMsg comparePacsWithBill(List<NodeNeoDTO> drugLis, List<T> inputLis, String name) {

        Map<String,String> old_stand = new HashMap<>();
        if(ListUtil.isNotEmpty(drugLis) && ListUtil.isNotEmpty(inputLis)){
            List<String> dl = drugLis.stream().map(x -> x.getName()).collect(Collectors.toList());
            for (T lis:inputLis) {
                String val = (String)CoreUtil.getFieldValue(lis, "uniqueName");
                String val_name = (String)CoreUtil.getFieldValue(lis, "name");
                if(StringUtils.isNotBlank(val) && dl.contains(val)){
                    old_stand.put(val_name,val);
                }
            }
        }
        if(old_stand.size() > 0){
            String message = StringUtils.join(old_stand.keySet(), ",");
            String standNames = StringUtils.join(old_stand.values().stream().collect(Collectors.toList()),",");
            BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(message, name,standNames);
            return commonBillMsg;
        }
        return null;
    }
}
